#version 330 core
#pragma include "base.glsl"

in vec3 Color;
in vec3 FragPos;
in vec3 Normal;

in vec2 UV;
in vec4 FragPosLightSpace;

uniform float time;
uniform vec3 view_pos;

//Point Lights
const int MAX_POINT_LIGHTS = 50;
uniform vec3 point_light_color[MAX_POINT_LIGHTS];
uniform vec3 point_light_position[MAX_POINT_LIGHTS];
uniform float point_light_power[MAX_POINT_LIGHTS]; //just a multiplication factor for the light's strength (normally this is included in the color)
uniform float point_light_constant_attenuation[MAX_POINT_LIGHTS];
uniform float point_light_linear_attenuation[MAX_POINT_LIGHTS];
uniform float point_light_quadratic_attenuation[MAX_POINT_LIGHTS];
uniform bool point_light_visible[MAX_POINT_LIGHTS];
uniform int point_light_count = 0;

//Directional Lights
const int MAX_DIRECTIONAL_LIGHTS = 50;
uniform vec3 directional_light_color[MAX_DIRECTIONAL_LIGHTS];
uniform vec3 directional_light_direction[MAX_DIRECTIONAL_LIGHTS];
uniform float directional_light_intensity[MAX_DIRECTIONAL_LIGHTS];
uniform bool directional_light_visible[MAX_DIRECTIONAL_LIGHTS];
uniform int directional_light_count = 0;

//Spotlights
const int MAX_SPOT_LIGHTS = 50;
uniform vec3 spot_light_color[MAX_SPOT_LIGHTS];
uniform vec3 spot_light_direction[MAX_SPOT_LIGHTS];
uniform vec3 spot_light_position[MAX_SPOT_LIGHTS];
uniform float spot_light_cutoff[MAX_SPOT_LIGHTS];
uniform float spot_light_intensity[MAX_SPOT_LIGHTS];
uniform float spot_light_constant_attenuation[MAX_SPOT_LIGHTS];
uniform float spot_light_linear_attenuation[MAX_SPOT_LIGHTS];
uniform float spot_light_quadratic_attenuation[MAX_SPOT_LIGHTS];
uniform bool spot_light_visible[MAX_SPOT_LIGHTS];
uniform int spot_light_count = 0;

uniform sampler2D diffuse_texture;
uniform bool texture_active;

uniform sampler2D shadow_map;
uniform samplerCube omni_map;
uniform float far_plane;
// array of offset direction for sampling
vec3 gridSamplingDisk[20] = vec3[]
(
   vec3(1, 1,  1), vec3( 1, -1,  1), vec3(-1, -1,  1), vec3(-1, 1,  1), 
   vec3(1, 1, -1), vec3( 1, -1, -1), vec3(-1, -1, -1), vec3(-1, 1, -1),
   vec3(1, 1,  0), vec3( 1, -1,  0), vec3(-1, -1,  0), vec3(-1, 1,  0),
   vec3(1, 0,  1), vec3(-1,  0,  1), vec3( 1,  0, -1), vec3(-1, 0, -1),
   vec3(0, 1,  1), vec3( 0, -1,  1), vec3( 0, -1, -1), vec3( 0, 1, -1)
);

uniform float highness;
uniform int category;

layout (location = 0) out vec4 FragmentColor;
layout (location = 1) out vec4 BrightColor;
//layout (location = 2) out vec4 ClosestDepthMap;
//layout (location = 3) out vec4 CurrentDepthMap;

#pragma include "shading.glsl"

void main()
{
    //color=vec4(1,1,1,1);
    shading(FragmentColor, BrightColor/*, ClosestDepthMap, CurrentDepthMap*/);
	//BrightColor = vec4(1,1,1,1);
}