uniform float highness;
//uniform vec3 specular_texture_coordinates;
uniform vec3 character_position;
uniform int category;
uniform float time;

void morph_model_by_category(out vec4 morphed_position);
void morph_world(inout vec4 morphed_position);
void morph_model_character(out vec4 morphed_position);
void morph_model_shroom(out vec4 morphed_position);
void morph_model_tree_rock_whatever(out vec4 morphed_position);

void stime(in float t, out float nt);


void morph_model_by_category(out vec4 morphed_position) {
	switch(category) {
		case 0:
			morph_model_character(morphed_position);
			break;
		//case 1: //planet does not morph in model-space
		case 2:
			morph_model_shroom(morphed_position);
			break;
		case 3:
			morph_model_tree_rock_whatever(morphed_position);
		default: morphed_position = vec4(position.xyz, 1);
	}
}



void morph_model_character(out vec4 morphed_position) {
	morphed_position = vec4(
		position.x, 
		position.y, 
		position.z, 
		1.0f);
}

void morph_model_shroom(out vec4 morphed_position) {
    float t = sin(time);
	//stime(time, t);
	t = 10*time - 10*floor(time+0.8f); //saegezahn
	//t = sign(cos(t - 10*floor(t+0.7f); //dreieck
	morphed_position = vec4(
		position.x + position.y/5*sin(time)       + 0.5f*highness*sin(2*time+position.y*highness*30)      + position.x * highness * 1 * (((pow(sin((highness+1)*time), 2.f))+1) * pow(max(5*(position.y-t/3.7f),0.f),2.f) * pow(7.f, (-pow((max(2*(position.y-t/4.f), 0.f)), 2.f)))), 
		position.y,
		position.z + position.y/10*cos(0.2*time)  + 0.4f*highness*cos(1.53f*time+position.y*highness*27) + position.z * highness * 1 * (((pow(sin((highness+1)*time), 2.f))+1) * pow(max(5*(position.y-t/3.7f),0.f),2.f) * pow(7.f, (-pow((max(2*(position.y-t/4.f), 0.f)), 2.f)))), 
		1.0f);
}

void morph_model_tree_rock_whatever(out vec4 morphed_position) {
	morphed_position = vec4(position.x, position.y, position.z, 1.0f);
}



void morph_world(inout vec4 morphed_position) {
	float pos_damp = 0.1f;
	vec3 distance_character_vertex = character_position - vec3(morphed_position);
	float distance_length = length(distance_character_vertex);
	float distance_damp = 1-pow(2.f, -(0.001f*pow(distance_length, 3.5f)));
	morphed_position = vec4(
        morphed_position.x + distance_damp * ( 5*highness*sin(time+pos_damp*morphed_position.x)),
        morphed_position.y + distance_damp * ( 5*highness*cos(time/3+pos_damp*morphed_position.y)*cos(time/3+pos_damp*morphed_position.y)*sin(time/2+pos_damp*morphed_position.y) ),
        morphed_position.z + distance_damp * ( 5*highness*cos(0.37f*time+pos_damp*morphed_position.z) ),
        1.0f
    );
}

void stime(in float t, out float nt) {
	t = 10*nt - 10*floor(nt+0.7f);
}
