#version 430

in vec4 State;
in vec4 Vel;
layout (location = 0) out vec4 FragmentColor;

// from: https://stackoverflow.com/questions/15095909/from-rgb-to-hsv-in-opengl-glsl
vec3 hsv2rgb(vec3 c)
{
    vec4 K = vec4(1.0, 2.0 / 3.0, 1.0 / 3.0, 3.0);
    vec3 p = abs(fract(c.xxx + K.xyz) * 6.0 - K.www);
    return c.z * mix(K.xxx, clamp(p - K.xxx, 0.0, 1.0), c.y);
}

float dip(float a) {
    return a - floor(a);
}

void main(void){
  //hsv: h [0;0.16], s [], v []    1=360, 0.16 = 60.
  float h = sin(length(State.xyz)*0.213f)*0.1f+0.07f;
  vec3 outputColor = hsv2rgb(vec3(h, 1, (State.w/2.0f)+0.5f));
  FragmentColor = vec4(outputColor, State.w);
}