#version 430

layout(points) in;
layout(line_strip, max_vertices = 2) out;
in vec4 Vel[];

out vec4 Vel_gs;
out float Liveness;

uniform mat4  view;
uniform mat4  projection;
uniform vec4  view_pos;
uniform float length_factor;

void main(void) {
  vec4 state = gl_in[0].gl_Position;
  vec4 particlePos  = projection * view * vec4(state.xyz, 1);

  if (state.w > 0) {
	vec4 previousState = state - Vel[0] * length_factor;
	vec4 previousPos  = projection * view * vec4(previousState.xyz, 1);
	gl_Position = previousPos;
    Vel_gs = Vel[0];
	Liveness = previousState.w;
	EmitVertex();
	 
	gl_Position = particlePos;
	Vel_gs = Vel[0];
	Liveness = state.w;
	EmitVertex();
  }
}