#version 330 core
layout (location = 0) in vec3 position;

uniform mat4 light_view;
uniform mat4 light_projection;
uniform mat4 model;

#pragma include "morph.glsl"

void main()
{
	vec4 pos = vec4(position, 1);
	morph_model_by_category(pos);	 //morph in model-space
	vec4 world_pos = model * pos;
	morph_world(world_pos);
    gl_Position = light_projection * light_view * world_pos;
}