# Shroomita

## Controls

| Input          | Action                                              |
| -------------- | ------                                              |
| **WASD**       | **Move Character**                                  |
| **Left Click** | **Pick up Shroom**                                  |
| F2             | Display number of objects drawn on console on/off   |
| F3             | Wire Frame on/off                                   |
| F4             | Texture-Sampling-Quality: Nearest Neighbor/Bilinear |
| F5             | Mip Mapping-Quality: Off/Nearest Neighbor/Linear    |
| F8             | Viewfrustum-Culling on/off                          |
| F9             | Blending on/off                                     |
| **F10**        | **Particle Visibility on/off**                      |
| **F11**        | **Particle Simulation on/off**                      |
| **F12**        | **Reset Game Over State**                           |

## Implementation of Requirements

- Complex Objects: Shrooms
- Animated Objects: Neptune revolves around the sun, which is revolving around the earth. (Geocentric world view)
- View Frustum Culling: use **F8** to enable/disable and **F2** to print how many objects were drawn

## "Features" of the Game.

Collect shrooms to get high. Once you’ve eaten enough shrooms a different type of shroom will spawn.

Once high, if your highness ever reaches 0% the game is over. You can reset the game with **F12**.

## Illuminated and Textured Objects

- directional light for sunlight.
- spotlight for character-flashlight.
- pointlight at the sun’s center, to illuminate Neptune.
- shrooms are textured
- sun and neptune are textured

## Used Libraries
- Assimp
- Boost
- Bullet Physics
- DevIL
- Freetype
- GLEW
- GLFW
- GLM
- IrrKlang
- OpenGL

## Which Effects Are Implemented
- Shadow Mapping (with PCF)
    - Omni-Directional
- Bloom
- GPU Particle System (Compute Shader, Instancing)
- Spotlight

## References for Effects' Implementation

- Shadow Mapping: https://learnopengl.com/#!Advanced-Lighting/Shadows/Shadow-Mapping
- Omnidirectional Shadow Mapping: https://learnopengl.com/#!Advanced-Lighting/Shadows/Point-Shadows
- Bloom: https://learnopengl.com/#!Advanced-Lighting/Bloom
- GPU Particle System: Based on https://github.com/StanEpp/OpenGL_ParticleSystem
- Spotlight: http://www.lighthouse3d.com/tutorials/glsl-tutorial/spotlights/ 

## Special Features

The crosshair is blending with the background so it will be more visible on most backgrounds (Use F9 to toggle)

## Modeling Tools

- Blender
- Paint.NET

## Complex Interaction Sequences

To eat a shroom you must stand in proximity and left click with the mouse while aiming at it.
